/*
 * Demonstrate the NSRL C++ class
 */

#include "bloom.h"

#include <stdio.h>
#include <sys/types.h>
#include <string.h>


int main(int argc,char **argv)
{
    int errors =0;
    nsrl_bloom *b = nsrl_bloom_alloc();
    int i;

    nsrl_bloom_create(b,0,160,16,4,"A test bloom filter in memory");

    printf("Storing SHA1 values of even numbers into bloom filter...\n");
    for(i=0;i<1000;i+=2){
	char number[20];
	u_char buf[20];
	
	sprintf(number,"%d",i);
	SHA1((u_char *)number,strlen(number),buf);
	nsrl_bloom_add(b,buf);
    }
    printf("Checking to make sure that odd numbers are not present and even numbers are present\n");
    for(i=0;i<1000;i++){
	char number[20];
	u_char buf[20];
	
	sprintf(number,"%d",i);
	SHA1((u_char *)number,strlen(number),buf);
	int present = nsrl_bloom_query(b,buf);
	int even     = (i%2)==0;

	if(present != even){
	    printf("error: i=%d  present=%d even=%d\n",i,present,even);
	    errors++;
	}
    }
    printf("done\n");
    nsrl_bloom_free(b);
    return errors;
}
